IDLEMODE: 
        lbsr     WatchIN
        mvl      5
        mvf      WatchIN,F,BANK
        clrf     WatchIN+1,BANK  
        clrf     HGZT,BANK 
        clrf     H2MS,BANK
        mvl      0
        mvf      H2MSCNT,F,BANK  
IDLEMODELOOP:      
        call     ADCENONSTEP
        call     ClearLCD
        clrf     ADC0CN1,ACCE
        clrf     ADC0CN2,ACCE
        clrf     ADC0CN3,ACCE
        clrf     LCDCN1,ACCE
        clrf     PWRCN,ACCE
        clrf     SVSCN,ACCE
        clrf     INTE1,ACCE
        clrf     INTE2,ACCE
        clrf     INTF1,ACCE
        clrf     INTF2,ACCE
        mvf      PT2,W,ACCE
        andl     11111111b
        mvf      PT2PU,F,ACCE
        bsf      INTE1,WDTIE,ACCE
        bsf      INTE1,GIE,ACCE
        lbsr     WatchSw
        clrf     WatchSw,BANK
        clrf     WatchSw+1,BANK
        mvl      00000010b
        mvf      MCKCN2,F,ACCE
        mvl      00000000b
        mvf      MCKCN1,F,ACCE
 IDLEMODE_3:       
        bsf      TMACN,ENWDT,ACCE
        IDLE
        nop
        btss     PT2,5,ACCE
        jmp      IDLEMODE_3
        lbsr   WatchIN
        tfsz   WatchIN+1,BANK
        jmp    IDLEMODE_1
        tfsz   WatchIN,BANK
        jmp    IDLEMODE_1
        jmp    IDLEMODE_2
    IDLEMODE_1:
        btss    ADCFg,b_Zerom,ACCE   ; eLW~|U
        jmp    IDLEMODE_2
        mvl    1
        subf   WatchIN,F,BANK 
        mvl    0
        subc   WatchIN+1,F,BANK 
    IDLEMODE_2: 
        inf     H2MS,F,BANK
        mvf     H2MSCNT,W,BANK
        cpsg    H2MS,BANK
        jmp     IDLEMODE_3
        clrf    H2MS,BANK
                
;==========================================================
ADCStartUP:  
       mvl     01001000b
       mvf     INTE1,F,ACCE
       mvl     00000000b      
       mvf     INTE2,F,ACCE
       mvl     00000001b
       mvf     MCKCN1,F,ACCE
       mvl     00000001b
       mvf     MCKCN2,F,ACCE   ;
       mvl     00000000b
       call    ADCINISet1
       clrf    INTF1,ACCE
       
       call    Giveup2TimeADC
       
       
       mvff     ADC0RL,temp
       mvff     ADC0RM,temp+1
       mvff     ADC0RH,temp+2
       
       dcf     ADshiftbit,W,ACCE
            
      ADCStartUP_2:   
         bcf     status,c,acce
         btsz    ADC0RH,7,ACCE
         bsf     status,c,acce
         rrfc    temp+2,F,ACCE
         rrfc    temp+1,F,ACCE
         rrfc    temp,F,ACCE
         dcsz    wreg,F,ACCE
         jmp     ADCStartUP_2
         call     ADCLess40C 
       btss    status,c,acce
       jmp     ADCStartUP_5      ; <40
       btsz    ADCFg,b_Zerom,ACCE
       jmp     WakeMain
       jmp     IDLEMODELOOP
ADCStartUP_5:
       bsf     ADCFg,b_Zerom,ACCE
       lbsr    WatchIN
       tfsz    WatchIN,BANK
       jmp     IDLEMODELOOP
       tfsz    WatchIN+1,BANK
       jmp     IDLEMODELOOP
       jmp     ADCSTZero 


ADCStartUP_4: 
ADCSTZero:
       lbsr    HTMB
       mvl     4
       mvf     HTMB,F,BANK         
       mvl     11100000b
       mvf     ADC0CN3,F,ACCE
       clrf    INTF1,ACCE
       call    Giveup2TimeADC
       call    ADCFill
       bcf     ADCFg,b_stable,ACCE
       mvl     256-8
       mvf     ADStbcnt,F,ACCE
       bcf     ADCFg,b_ADCOK,ACCE
       bsf     INTE1,GIE,ACCE
ADCSTZero_1:       
       call    GETADC
       btss    ADCFg,b_ADCOK,ACCE
       jmp     ADCSTZero_1
       bcf     ADCFg,b_ADCOK,ACCE
       mvff    ADCOUTL,Temp
       mvff    ADCOUTM,Temp+1
       mvff    ADCOUTH,Temp+2
       call     ADCLess40C 
       btsz    status,c,acce
       jmp     WakeMain
       
       btss    ADCFg,b_stable,ACCE
       jmp     ADCSTZero_2
       call    CKOVZero
       btsz    Wreg,0,ACCE
       jmp     ADCSTZero_2
       mvff    ADCOUTL,Zero
       mvff    ADCOUTM,Zero+1
       mvff    ADCOUTH,ZeroH
       jmp     ADCGVLOOPTM
   ADCSTZero_2:    
       lbsr    HTMB
       tfsz    HTMB,BANK
       jmp      ADCSTZero_1
       jmp     IDLEMODELOOP     ;pWL4íh^IDLE
ADCGVLOOPTM:     
       lbsr    HGZT
       mvl     High  ADCST1PM              ; PCLATH sD_l}(bit 15~8)
       mvf     PCLATH,F,ACCE
       mvf     HGZT,W,BANK
       addl    Low   ADCST1PM              ; ոDȻP JPBmۥ[O_WL0x100
       jnc     ADCST1ProM
       inf     PCLATH,F,ACCE         ; pGWL0x100h [PCLATU,PCLATH] + 1
    ADCST1ProM:    
       mvl     ADCST1PM
       addf    HGZT,W,BANK
       mvf     PCLATL,F,ACCE         ; ePCLATL + D
    ADCST1PM:    
 ;===================================================
       jmp     ADCSTRA1
       jmp     ADCSTRA2
       jmp     ADCSTRA3
       jmp     ADCSTRA4
       jmp     ADCSTRA5
       jmp     ADCSTRA6
       jmp     ADCSTRA7
       jmp     ADCSTRA8
 
      
 
 ADCSTRA1:
        mvl     1
        mvf     HGZT,F,BANK
        mvl     10
        mvf     WatchIN,F,BANK
        jmp     IDLEMODELOOP
 ADCSTRA2:
        mvl     2
        mvf     HGZT,F,BANK
        mvl     30
        mvf     WatchIN,F,BANK
        mvl     01h
        mvf     H2MSCNT,F,BANK      ; 30אּ 2S y
        jmp     IDLEMODELOOP
 ADCSTRA3:
        mvl     3
        mvf     HGZT,F,BANK
        mvl     60
        mvf     WatchIN,F,BANK
        jmp     IDLEMODELOOP
 ADCSTRA4:
        mvl     4
        mvf     HGZT,F,BANK
        mvl     120
        mvf     WatchIN,F,BANK
        jmp     IDLEMODELOOP
 ADCSTRA5:
        mvl     5
        mvf     HGZT,F,BANK
        mvl     02Ch
        mvf     WatchIN,F,BANK
        mvl     01h
        mvf     WatchIN+1,F,BANK    ; 300 S
        jmp     IDLEMODELOOP
 ADCSTRA6:
        mvl     6
        mvf     HGZT,F,BANK
        mvl     058h
        mvf     WatchIN,F,BANK
        mvl     02h
        mvf     WatchIN+1,F,BANK    ; 600 S
        mvl     01h
        mvf     H2MSCNT,F,BANK      ; 10אּ 2S y
        jmp     IDLEMODELOOP
 ADCSTRA7:
        mvl     7
        mvf     HGZT,F,BANK
        mvl     008h
        mvf     WatchIN,F,BANK
        mvl     07h
        mvf     WatchIN+1,F,BANK    ; 1800 S
        jmp     IDLEMODELOOP
 ADCSTRA8:
        mvl     7
        mvf     HGZT,F,BANK
        mvl     010h
        mvf     WatchIN,F,BANK
        mvl     0Eh
        mvf     WatchIN+1,F,BANK    ; 3600 S
        jmp     IDLEMODELOOP
       
;===================================================
WakeMain:
       mvl     11100000b
       mvf     ADC0CN3,F,ACCE
       call    INISet
       call    Giveup2TimeADC
       call    ADCFill
       bsf     INTE1,GIE,ACCE
       jmp      Mainloop       
       