Delay2ms:   ; about 6ms
    ;   mvl     2
    ;   mvf     temr,F,ACCE
    ;   mvl     244
       mvl     1
       mvf     temr,F,ACCE
       mvl     100
       jmp     Delay10ms_1
Delay10ms:
        mvl     20
        mvf     temr,F,ACCE
     Delay10ms_2:   
        mvl     0
     Delay10ms_1:   
        dcsz    WREG,F,ACCE
        jmp     Delay10ms_1
        dcsz    temr,F,ACCE
        jmp     Delay10ms_2
        ret  
;=================================          
ADCINISet:
       mvl     11100000b
  ADCINISet1:
       mvf     ADC0CN3,F,ACCE
       mvl     11110000b
       mvf     PWRCN,F,ACCE      
       mvl     00011110b
       mvf     ADC0CN1,F,ACCE
       mvl     00001101b
       mvf     ADC0CN2,F,ACCE
       mvl     01101100b
       mvf     AINET1,F,ACCE
       mvl     01000100b
       mvf     AINET2,F,ACCE
       call     delay2ms
       bsf      ADC0CN1,ENADC,ACCE
       ret
;=================================          
INISet:       
       bsf     MCKCN3,PERCK,ACCE   ; Select clock source = HS clock / 32      
       mvl     11000011b           ; Watchdog enable 1/s
       mvf     TMACN,F,ACCE     
      ;==========INTE Set============================
       mvl       01001000b
       mvf       INTE1,F,ACCE
       mvl       00000000b      
       mvf       INTE2,F,ACCE
      ;======================================
       mvl      256-3 
       mvf      GvupADC,F,ACCE
      clrf      INTF2,ACCE
      clrf      INTF1,ACCE   
      call    ClearLCD
       lbsr    HTMB
        mvl     10
        mvf     HTMB,F,BANK      ; 0 10
        mvl     5
        mvf     HTMBZ,F,BANK     ; íw5
        mvl     30
        mvf     HTotalTM,F,BANK  ;`qɶ30
      ret
;==============================
ADCFillStb:
         mvl     256-8
         mvf    ADStbcnt,F,acce
         bcf     INTE1,GIE,ACCE
         call   ADCFill
         bsf     INTE1,GIE,ACCE
         bcf     ADCFg,b_stable,ACCE   
         bcf     ADCFg,b_ADCOK,ACCE
         ret
ADCFill:
         ldpr    ADBUF,FSR0
         mvl     7
      ADCFill_LOOP:   
         mvff    ADC0RL,POINC0
         mvff    ADC0RM,POINC0
         mvff    ADC0RH,POINC0
         dcsz    WREG,F,ACCE
         jmp     ADCFill_LOOP
         mvff    ADC0RL,ADA1
         mvff    ADC0RM,ADA1+1
         mvff    ADC0RH,ADA1+2
         ret
;==============================
COMFHTEMP3:        
        comf     HTemp+3+2,F,BANK
        comf     HTemp+3+1,F,BANK
        comf     HTemp+3,F,BANK
        insz     HTemp+3,F,BANK
        ret
        insz     HTemp+3+1,F,BANK
        ret
        inf      HTemp+3+2,F,BANK
        ret   
;==============================
CKHTEMPSN:
        bsf      status,c,acce     
        tfsz     HTemp+3+2,BANK
        ret
        mvf      HTemp,W,BANK
        subf     HTemp+3,W,BANK
        mvf      HTemp+1,W,BANK
        subc     HTemp+3+1,W,BANK
        ret
;==============================
SNTIMESIX:        
        mvf      sn,W,ACCE
        mvf      HTEMP,F,BANK
        clrf     HTEMP+1,BANK
        mvl      5
        mvf      HTEMP+3,F,BANK
     SNTIMESIX_1:   
        mvf      sn,W,ACCE
        addf     HTEMP,F,BANK
        mvl      0
        addc     HTEMP+1,F,BANK
        dcsz     HTEMP+3,F,BANK
        jmp      SNTIMESIX_1
        ret
        
;===========================================       
PROCAMainPRO:
       mvf     Zero,W,ACCE
       btsz    RLCDG,b_ltare,ACCE
       mvf     Tare,W,ACCE
       subf    adaz,w,acce
       mvf     temp,F,ACCE
       mvf     Zero+1,W,ACCE
       btsz    RLCDG,b_ltare,ACCE
       mvf     Tare+1,W,ACCE
       subc    adaz+1,W,ACCE
       mvf     temp+1,F,ACCE
       mvf     ZeroH,W,ACCE
       btsz    RLCDG,b_ltare,ACCE
       mvf     TareH,W,ACCE
       subc    adazH,W,ACCE
       mvf     temp+2,F,ACCE
       btss    temp+2,7,acce
       jmp     PROCA_czero
       comf    temp,f,acce
       comf    temp+1,f,acce
       comf    temp+2,f,acce
       insz    temp,f,acce
       jmp     PROCA_czero
       insz    temp+1,f,acce
       jmp     PROCA_czero
       inf     temp+2,f,acce
   PROCA_czero:    
       tfsz    temp+2,ACCE
       jmp     PROCA_czero1
       tfsz    temp+1,ACCE
       jmp     PROCA_czero1
       mvl     10
       cpsl    temp,acce
       jmp     PROCA_czero1
       bcf     RLCDG,b_ltare,ACCE
       bcf     RLCDG,b_zero,ACCE
    PROCA_czero1:   
       btss    RLCDG,b_ltare,ACCE
       jmp     PROCA_DOZero
       mvf     Tare,W,ACCE
       subf    ADCOUTL,W,ACCE
       mvf     Temp,F,ACCE
       mvf     Tare+1,W,ACCE
       subc    ADCOUTM,W,ACCE   
       mvf     Temp+1,F,ACCE
       mvf     TareH,W,ACCE
       subc    ADCOUTH,W,ACCE   
       mvf     Temp+2,F,ACCE
       bcf     ADCFg,b_neg,ACCE 
       btss    Temp+2,7,ACCE
       jmp     PROCA_MM2
     ;=======================  
       mvff    temp,HADWeight
       mvff    temp+1,HADWeight+1
       mvff    temp+2,HADWeight+2
     ;=======================  
       bsf     ADCFg,b_neg,ACCE 
       comf    Temp,F,ACCE
       comf    Temp+1,F,ACCE
       comf    Temp+2,F,ACCE
       insz    Temp,F,ACCE
       jmp     PROCA_MM2
       insz    Temp+1,F,ACCE
       jmp     PROCA_MM2
       inf     Temp+2,F,ACCE
   PROCA_MM2:
       jmp     PROCA_MM1
 PROCA_DOZero:      
       mvf     Zero,W,ACCE
       subf    ADCOUTL,W,ACCE
       mvf     Temp,F,ACCE
       mvf     Zero+1,W,ACCE
       subc    ADCOUTM,W,ACCE   
       mvf     Temp+1,F,ACCE
       mvf     ZeroH,W,ACCE
       subc    ADCOUTH,W,ACCE   
       mvf     Temp+2,F,ACCE
     ;=======================  
       mvff    temp,HADWeight
       mvff    temp+1,HADWeight+1
       mvff    temp+2,HADWeight+2
     ;=======================  
       bcf     ADCFg,b_neg,ACCE 
       btss    Temp+2,7,ACCE
       jmp     PROCA_MM1
       bsf     ADCFg,b_neg,ACCE 
       comf    Temp,F,ACCE
       comf    Temp+1,F,ACCE
       comf    Temp+2,F,ACCE
       insz    Temp,F,ACCE
       jmp     PROCA_MM1
       insz    Temp+1,F,ACCE
       jmp     PROCA_MM1
       inf     Temp+2,F,ACCE
   PROCA_MM1:
        ret 
;=============================================================
Giveup2TimeADC:     
       mvl     3
    Gp2TimeADC_1:   
       btss    INTF1,ADCIF,ACCE
       jmp     Gp2TimeADC_1
       bcf     INTF1,ADCIF,ACCE
       dcsz    WREG,F,ACCE
       jmp     Gp2TimeADC_1
       ret

;=============================================================
ZeroTrace:       
       btss    ADCFg,b_stable,ACCE
       jmp     ZeroTrac_NSTB
       tfsz    Tm1s,ACCE
       jmp     ZeroTrac_ZSTB
       btsz     RLCDG,b_ltare,ACCE
       jmp     ZeroTrac_NSTB
       call    CKOVZero
       btsz    Wreg,0,ACCE
       jmp     ZeroTrac_NSTB
       mvf     Zero,W,ACCE
       subf    ADCOUTL,W,ACCE
       mvf     Temp,F,ACCE
       mvf     Zero+1,W,ACCE
       subc    ADCOUTM,W,ACCE
       mvf     Temp+1,F,ACCE
       mvf     ZeroH,W,ACCE
       subc    ADCOUTH,W,ACCE
       mvf     Temp+2,F,ACCE
       bcf     ADCFg,b_neg,ACCE 
       btss    Temp+2,7,ACCE
       jmp     ZeroTrac_NTB1
       bsf     ADCFg,b_neg,ACCE 
       comf    Temp,F,ACCE
       comf    Temp+1,F,ACCE
       comf    Temp+2,F,ACCE
       insz    Temp,F,ACCE
       jmp     ZeroTrac_NTB1
       insz    Temp+1,F,ACCE
       jmp     ZeroTrac_NTB1
       inf     Temp+2,F,ACCE
   ZeroTrac_NTB1:
       tfsz    Temp+2,ACCE
       jmp      ZeroTrac_NSTB
       tfsz    Temp+1,ACCE
       jmp      ZeroTrac_NSTB
       mvf     sn,W,ACCE
       cpsg    temp,acce 
       jmp     ZeroTrac_NTB2
       cpse    temp,acce
       jmp      ZeroTrac_NSTB
   ZeroTrac_NTB2:
       mvff    ADCOUTL,Zero
       mvff    ADCOUTM,Zero+1
       mvff    ADCOUTH,ZeroH
  ZeroTrac_NSTB:
       mvl     200
       mvf     Tm1s,F,ACCE
  ZeroTrac_ZSTB:     
       ret       
;===============================================================       
;pGTemp - ADAZ <40 h C = 0
ADCLess40C:       
       mvf    Zero,w,acce
       subf   temp,f,acce 
       mvf    Zero+1,w,acce
       subc   temp+1,f,acce 
       mvf    Zero+2,w,acce
       subc   temp+2,f,acce 
       btss   temp+2,7,acce
       jmp    ADCStartUP_3
       comf   temp,f,acce
       comf   temp+1,F,ACCE
       comf   temp+2,f,acce
       insz   temp,f,acce
       jmp    ADCStartUP_3
       insz   temp+1,f,acce
       jmp    ADCStartUP_3
       inf    temp+2,f,acce
    ADCStartUP_3:   
       mvff    temp,HTemp
       mvff    temp+1,HTemp+1
       mvff    temp+2,HTemp+2
       mvl     HTemp
       mvf     md1,F,ACCE
       mvl     adspanhigh
       mvf     md2,F,ACCE
       mvl     HTemp+3
       mvf     md3,F,ACCE
       mvl     3
       mvf     mdl1,F,ACCE
       mvl     4
       mvf     mdl2,F,ACCE
       lbsr    1
       call    multiply
       lbsr    1
       mvl     40
       subf    HTemp+3+4,W,bank
       mvl     0
       subc    HTemp+3+5,W,bank
       ret