         btss   INTF1,ADCIF,ACCE
         jmp    Inter_3_out
         bcf    INTF1,ADCIF,ACCE
         mvff   ADC0RL,ADNEWL
         mvff   ADC0RM,ADNEWM
         mvff   ADC0RH,ADNEWH
   ;--------------
      ;=====
      ; | - NEW|  --> ADCTEMP
      ; IF Negative then Flag.ADSign = 1
      ;=====
     INTADC_AVBegin: 
         mvf     ADNEWL,W,ACCE
         subf    ada1,W,ACCE
         mvf     ADCTEMP,F,ACCE
         mvf     ADNEWM,W,ACCE
         subc    ada1+1,W,ACCE
         mvf     ADCTEMP+1,F,ACCE
         mvf     ADNEWH,W,ACCE
         subc    ada1+2,W,ACCE
         mvf     ADCTEMP+2,F,ACCE
         bcf     Flag,ADSign,ACCE    
         btss    ADCTEMP+2,7,ACCE
         jmp     INTADC_AV1
         bsf     Flag,ADSign,ACCE    
         comf    ADCTEMP,F,ACCE
         comf    ADCTEMP+1,F,ACCE
         comf    ADCTEMP+2,F,ACCE
         mvl     1
         addf    ADCTEMP,F,ACCE  
         mvl     0
         addc    ADCTEMP+1,F,ACCE  
         addc    ADCTEMP+2,F,ACCE  
      INTADC_AV1:   
        ;===
        ;   | - NEW| < ADShiftbit ?
        ;   P_bit 10
        ;===
         tfsz    ADCTEMP+2,ACCE
         jmp     INTADC_OUTAV
   ;      mvl     1
   ;      mvf     ADCTempBuf,F,ACCE
   ;      clrf    ADCTempBuf+1,ACCE
   ;      tfsz    ADshiftbit,ACCE
   ;      jmp     INTADC_AV1_1
   ;      jmp     INTADC_AV1_2
   ;    INTADC_AV1_1:  
   ;      mvf     ADshiftbit,W,ACCE
   ;    INTADC_AV1Loop:
   ;      bcf     status,C,ACCE
   ;      rlfc    ADCTempBuf,F,ACCE
   ;      rlfc    ADCTempBuf+1,F,ACCE        
   ;      dcsz    WREG,F,ACCE
   ;      jmp     INTADC_AV1Loop
   ;    INTADC_AV1_2:
         mvl     04h
         mvf     ADCTempBuf+1,F,ACCE
         mvl     0
         mvf     ADCTempBuf,F,ACCE  
         mvf     ADCTempBuf,W,ACCE
         subf    ADCTemp,W,ACCE
         mvf     ADCTempBuf+1,W,ACCE
         subc    ADCTemp+1,W,ACCE
         btsz    STATUS,C,ACCE
         jmp     INTADC_OUTAV
   ;====
   ;   (New + buf1 + buf2 + buf3 + buf4  + buf5 + buf6 + buf7) / 8 --> ada1        
   ;====      
         ldpr    ADBUF,FSR0
         mvl     0
         btsz    ADNEWH,7,ACCE
         mvl     0FFh
         mvf     ADCTemp,F,ACCE
         mvf     ADNEWL,W,ACCE
         addf    POINC0,W,ACCE
         mvf     ada1,F,ACCE
         mvf     ADNEWM,W,ACCE
         addc    POINC0,W,ACCE
         mvf     ada1+1,F,ACCE
         mvf     ADNEWH,W,ACCE
         addc    INDF0,W,ACCE
         mvf     ada1+2,F,ACCE
         mvl     0
         btsz    POINC0,7,ACCE
         mvl     0FFh
         addc    ADCTemp,F,ACCE
         
         mvl     6
         mvf     ADCTemp+1,F,ACCE
     INTADC_AV2LOOP:  
         mvf     POINC0,W,ACCE
         addf    ada1,F,ACCE
         mvf     POINC0,W,ACCE
         addc    ada1+1,F,ACCE
         mvf     INDF0,W,ACCE
         addc    ada1+2,F,ACCE
         mvl     0
         btsz    POINC0,7,ACCE
         mvl     0FFh
         addc    ADCTemp,F,ACCE
         dcsz    ADCTemp+1,F,ACCE
         jmp     INTADC_AV2LOOP

   ;====
   ;   New-->buf1-->buf2-->buf3-->buf4-->buf5-->buf6-->buf7        
   ;   ADCounter = 0
   ;====      
         ldpr    ADBUF+20,FSR0
         ldpr    ADBUF+17,FSR1
         mvl     6
     INTADC_AV3LOOP:    
         mvff    PODEC1,PODEC0
         mvff    PODEC1,PODEC0
         mvff    PODEC1,PODEC0
         dcsz    WREG,F,ACCE
         jmp     INTADC_AV3LOOP
         mvff    ADNEWH,PODEC0
         mvff    ADNEWM,PODEC0
         mvff    ADNEWL,PODEC0
         mvl     3
      INTADC_AD4LOOP:   
         bcf     STATUS,C,ACCE
         rrfc    ADCTemp,F,ACCE
         rrfc    ada1+2,F,ACCE
         rrfc    ada1+1,F,ACCE
         rrfc    ada1,F,ACCE
         dcsz    WREG,F,ACCE
         jmp     INTADC_AD4LOOP
         bcf     Flag,ADCounter,ACCE
         jmp     INTADC_AVEND
   ;========================================      
   INTADC_OUTAV:
       ;==
       ;  ADCounter = 0 ?  
       ;==         
         btss    Flag,ADCounter,ACCE
         jmp     INTADC_OUTAVONE
       ;==
       ;  S xor Sb = 0 ? O_PV
       ;  ADSignb = bit 2 
       ;==         
         mvl     00000000b
         btsz    Flag,ADSign,ACCE
         mvl     00000100b     
         xorf    Flag,W,ACCE
         andl    00000100b
         btsz    STATUS,Z,ACCE 
         jmp     INTADC_NEWAV
         jmp    INTADC_OUTAVONE
        ;==
        ; (Latch + New) /2   
        ;== 
        ; mvf    ADLatchL,W,ACCE
        ; addf   ADNEWL,F,ACCE
        ; mvf    ADLatchM,W,ACCE
        ; addc   ADNEWM,F,ACCE
        ; mvf    ADLatchH,W,ACCE
        ; addc   ADNEWH,F,ACCE
        ; rrfc   ADNEWH,F,ACCE 
        ; rrfc   ADNEWM,F,ACCE 
        ; rrfc   ADNEWL,F,ACCE
        ; bcf    Flag,ADCounter,ACCE
        ; jmp    INTADC_AVBegin
   ;===============================      
   INTADC_NEWAV:
     ;========
     ; Load New to buf1 ~ buf7
     ; Load New to 
     ; ADCounter = 0
     ;========
         ldpr    ADBUF,FSR0
         mvl     7
      INTADC_NEWAVLOOP:   
         mvff    ADNEWL,POINC0
         mvff    ADNEWM,POINC0
         mvff    ADNEWH,POINC0
         dcsz    WREG,F,ACCE
         jmp     INTADC_NEWAVLOOP
         mvff    ADNEWL,ada1
         mvff    ADNEWM,ada1+1
         mvff    ADNEWH,ada1+2
         bcf     Flag,ADCounter,ACCE
         jmp     INTADC_AVEND
   ;===============================      
   INTADC_OUTAVONE:      
   ;==
   ;  NEW --> LATCH 
   ;==      
         bcf     Flag,ADSignb,ACCE    
         btsz    Flag,ADSign,ACCE    
         bsf     Flag,ADSignb,ACCE    
         mvff    ADNEWH,ADLatchH        
         mvff    ADNEWM,ADLatchM        
         mvff    ADNEWL,ADLatchL  
         bsf     Flag,ADCounter,ACCE      
INTADC_AVEND:
         mvff    ADA1,ADCOUTL         
         mvff    ADA1+1,ADCOUTM         
         mvff    ADA1+2,ADCOUTH
         bcf     STATUS,C,ACCE
         rlfc    ADCOUTL,F,ACCE
         rlfc    ADCOUTM,F,ACCE
         rlfc    ADCOUTH,F,ACCE
         bcf     ADCOUTH,7,ACCE
         btsz    STATUS,C,ACCE
         bsf     ADCOUTH,7,ACCE
         tfsz    ADshiftbit,ACCE
         jmp     INTADC_AVEND1
         jmp     INTADC_AVEND2
      INTADC_AVEND1:  
         mvf     ADshiftbit,W,ACCE
         mvf     ADCTemp,F,ACCE
      INTADC_AVENDLOOP:   
         bcf     status,c,acce
         btsz    ADA1+2,7,ACCE
         bsf     status,c,acce
         rrfc    ADCOUTH,F,ACCE
         rrfc    ADCOUTM,F,ACCE
         rrfc    ADCOUTL,F,ACCE
         dcsz    ADCTemp,F,ACCE
         jmp     INTADC_AVENDLOOP
      INTADC_AVEND2:   
         bsf     ADCFg,b_ADCint,ACCE
         bsf     Flag,b_ADCPCOK,ACCE
INTADC_ADCEND:                   
;=========================================================================================
     Inter_3_out:    
