;=======================================
;SPIϥΨ쪺Register
;    SPICNT      1 byte
;    SPIM        1 byte
;    SPIINDEXH   1 byte
;    SPIINDEXL   1 byte
;    RSLEN       1 byte
;    RSTX        1 byte
;=======================================
FSR0HTemp    equ    0FFH
FSR0LTemp    equ    0FEh   ; 0FE
FSR1HTemp    equ    0FDh   ;0FD
FSR1LTemp    equ    0FCh     ;0FC
CALLEN       equ    0FBh    ; sեȪ
TabadrTmpL    equ    0F9h;    NAddress High
TabadrTmpH    equ    0F8h;    NAddress Low 
SPIDATA      equ    0F7h   ;0F7
RSLEN        equ    0F1h    ;0F1
CALNUM       equ    0F5h   ; NեȪƧ
RSCNT        equ    0F4h        ;0F4
ADCOUTH      equ    0F6h
ADCOUTM      equ    0F3h
ADCOUTL      equ    0F2h
RSTX         equ    0F0h       ;0F0
   b_ANTX    equ    0
   b_ADCbg   equ    1    ; Catch ADC
   b_ADCcnn  equ    2
   b_ADCkn   equ    3
   b_tm      equ    4
   b_rdEEPROM  equ  5
   b_wrEEPROM  equ  6
   b_EEPROMERR equ  7
;==========================================================
MD1          equ    080h
dsp          equ    080h
dsp1         equ    086h
VSQRT        equ    080h
s_reg_EE     equ    080h
eeaddress    equ    081h
temr         equ    082h
eedatemp     equ    083h
r_Len_EE     equ    084h
SQRTBuf      equ    084h
RSQRT        equ    088h 
MD2          equ    081h
MD3          equ    082h
MDL1         equ    083h
MDL2         equ    084h
MDL3         equ    085h
MD4          equ    086h
S_REG        equ    08Ch
r_Len        equ    08Dh
SQRTmp       equ    08Eh
WeightBuf    equ    08Eh
Temp         equ    092h 
sn           equ    09Ch
ADAZ1H       equ    09Dh
ADLatchL      equ    09Eh
ADLatchM      equ    09Fh
ADCMaxH      equ    0A0h
PreZeroH     equ    0A1h
RAMClient    equ    0A2h
RAMStart     equ    0A3h
RAMFg        equ    0A4h    ; 0A4   
   bClient   equ    0
   bStart    equ    1
   bClient1  equ    2
   b_FlashR  equ    3
   b_Regsp   equ    4
   b_Regspbg equ    5
   b_Regspok equ    6
   
RAMBKL        equ     0A5h   
RAMBKH        equ     0A6h
CALADDRH      equ     0A5h   ; եȪ_l}
CALADDRL      equ     0A6h   ; եȪ_l}
Tm            equ    0A7h
Aub           equ    0A8h
ADCFg         equ    0A8h
   bg         equ    0
   b_ADCint   equ    1
   b_neg      equ    2
   b_stable   equ    3
   b_nonevalue   equ   4
   b_ADCOK    equ    5
   b_Tarem     equ    6
   b_Zerom     equ    7
ADBG          equ    0A9h         ; 0A9 ~  0AE
ADCTemp        equ    0A9h
;;0ACh  not use
;ADshiftbit    equ    0ADh
Tm1s         equ     0ADh
ADLatchH      equ     0AEh
ADA1          equ    0AFh         ; 0AF
ADStable     equ     0B2h        ; 0B2
KeyFlash     equ     0b5h
eecnt        equ     0B6h         ; 0B6
ADStbcnt     equ     0B7h
KeyStill     equ     0B8h
KeyCnt       equ     0B9h 
UWeight      equ     0BAh
CWeight      equ     0BCh
ADPoint      equ     0BEh
ADAZ         equ     0BFh
ADAZH        equ     0C1h                                
ADSPAN       equ     0C2h
ADSPANH       equ    0C4h
ADshiftbit    equ    0C5h
ADAZ1        equ     0C6h         
Tare         equ     0C8h      
TareH        equ     0CAh
Zero         equ     0CBh
ZeroH        equ     0CDh
ADCMax       equ     0CEh
PreZero      equ     0D0h
Flag         equ     0D2h
   b_ADS     equ     0
   ADSign    equ     1
   ADSignb   equ     2
   ADCounter equ     3  
   b_ADCPCOK equ     4  
   b_FlashW   equ     5
   b_FlashOK  equ     6
   b_FlashEr  equ   7
   
GvupADC         equ  0D3h
ADNEWL       equ     0D4h
ADNEWM       equ     0D5h
ADNEWH        equ    0D6h
ADBUF        equ     0D7h      ; 0D7
ADCTempBuf    equ     0ECh     ; 0EC
;0eeh , 0efh not used
;TabadrTmpL   equ    0EEh
;TabadrTmpH   equ    0EFh
;==========================================================
ScalData1    equ    0100h   ; ˸m1O϶ form 0x140 ~ 0x17F  MgMainData
PORTCOUNT    equ    0100h
SaveData     equ    0100h   ; sxO϶ form 0x120 ~ 0x17F @48 
SaveDataend  equ    011Fh
STEPLEN      equ    0120h
STEPLENBF    equ    0121h
LOOPLEN      equ    0122h
STEP         equ    0124h
STEPBF       equ    0125h
Steptemp     equ    0126h
REGAddr      equ    0128h
REGData0     equ    0130h
REGData1     equ    0138h
REGData2     equ    0140h
REGData3     equ    0148h
REGData4     equ    0150h
REGData5     equ    0158h
REGData6     equ    0160h
REGData7     equ    0168h
FlashAddr    equ    0170h
FlashLen     equ    0173h
FlashData    equ    0176h
FlashGvup    equ    0177h
WatchSw      equ    0120h
WatchIN      equ    0123h
adspanhigh   equ    0125h
HTM1S        equ    0129h
HADWeight    equ    012Ah
HTMB         equ    012Dh
HADWBUF      equ    012Eh
HTMBZ        equ    0131h
HGZT         equ    0132h
HTotalTM     equ    0133h
H2MS         equ    0134h
H2MSCNT      equ    0135h
HTemp        equ    0170h
;==================================================
KeyPT      equ     PT1
       bK1         equ   7
       bK2         equ   3
KeyPT2     equ     PT2        
       bK3         equ   4   
;====================================
RLCDG      equ     LCD6
       b_lbat       equ    0
       b_lneg       equ    4
       b_ltare      equ    5
       b_zero       equ    6    
     ;  b_lg         equ    4         
       b_loz        equ    5         
       b_ldwt       equ    6         
       b_lozt       equ    7  
LCD_G      equ     LCD5
       b_lg         equ    7              
UNITLCD7    EQU     LCD7
      b_MM      equ 0
      b_K       equ 4
      b_A       equ 5
      b_R       equ 6
      b_V       equ 7

UNITLCD6    EQU     LCD6
      b_lb1     equ 0
      b_lb2     equ 1
      b_lb3     equ 2
      b_lb4     equ 3 
      b_negative    equ 4 
      b_m       equ 7  
      
;UNITC   EQU     00AH    ;LCD7
;UNITF   EQU     006H    ;LCD7
;===================================================
pt2en         equ     TRISC2
eeclk            equ    2
eedata           equ    3
ptclkem           equ    pt2en     ; 0 input  , 1 output
ptdaem         equ     pt2en
ptda             equ    pt2
ptclk            equ    pt2
;======================================================
FSPIDIEN        equ     TRISC2
FSPIDIPU        equ     PT2PU
FSPIDI          equ     PT2
                bSPIDI      equ     4 
FSPIDOEN        equ     TRISC1
FSPIDOPU        equ     PT1PU
FSPIDO          equ     PT1
                bSPIDO      equ     3
FSPICKEN        equ     TRISC1
FSPICKPU        equ     PT1PU
FSPICK          equ     PT1
                bSPICK      equ     7
FSPICSEN        equ     TRISC1
FSPICSPU        equ     PT1PU
FSPICS          equ     PT1
                bSPICS      equ     4
;==================================================
PTSCK        equ    PT1
   b_PTSCK   equ    0
PTSDI        equ    PT1
   b_PTSDI   equ    1
PTSDO        equ    PT1
   b_PTSDO   equ    5
TRISDO       equ    TRISC1
   b_TRISDO  equ    5
PTCS         equ    PT1
   b_PTCS    equ    0  
                          
                 