;=======================================================================
; SPICNT : SPIƶq
;          SPICNT = 0 ==>  SPIBUFBit 7 = 1 Ū , SPIBUFBit 7 = 0 g
;          SPICNT = 1 ==>  SPIBUF = wRAM Address  Low byte  --> FSR0L
;          SPICNT = 2 ==>  SPIBUF = wRAM Address  High byte --> FSR0H
;          SPICNT > 2 ==>   wRAM Address iŪgʧ@
; SPICNTiWL 255
; CS PIN 10  01 |M SPICNT
;=======================================================================
      org   0000h
ProgramReset:      
         jmp   ProBegin
         nop
         jmp   0
      org   0004h
        Include  Interrupt.asm
;======================================================== 
ProBegin: 
       include   SysIni.asm
;==============================================================
       include   SYSINITABLE.asm
;==============================================================  
MainLoop:
        CWDT
        btsz    SVSCN,SVSOP,ACCE
        bsf     RLCDG,b_lbat,ACCE
        btss    SVSCN,SVSOP,ACCE
        bcf     RLCDG,b_lbat,ACCE
        btsz  ADCFg,b_nonevalue,ACCE
        jmp   CALADCPRO
        include   Keyscan.asm
        include   MainPro.asm
        include   MainWeight.asm
      ;  btsz     PT1,0,0
      ;  jmp      Main_End
      ;  call      Delay10ms
      ;  btss     PT1,0,0
      ;  jmp      Main_Sleep
;============================================================
   Main_End:     
       jmp  MainLoop
;----------------------------------------------
;ե{
CALADCPRO:
     ;  bcf     TRISDO,b_TRISDO,ACCE    ; T
       btss    KeyPT,bK1,ACCE
       jmp     CALADCPRO
       call    delay10ms
       btss    KeyPT,bK1,ACCE
       jmp     CALADCPRO
       clrf    KeyCnt,ACCE
       call    ClearLCD
     ;  clrf    PT1M2,ACCE       ; TSPI
       mvl     16
       cpsg    ADshiftbit,ACCE
       jmp     CALADCPRO_1
       mvl     6
       mvf     ADshiftbit,F,ACCE
    CALADCPRO_1:   
       include   ADCCAL.asm              
;=================================================
       include  SLEEPROG.asm
;=================================================
       include  IDLEPROG.asm
       
;=================================================
     include    ADC.asm
;=======================================================================================================              
      include   Math.asm
      Include  H08A.INC
      include  Main.inc
      include   Display.asm
      include   LCDINDX.asm
      include    Subroutine.asm
;======================================================================      
ADCENONSTEP:      
       bcf      ADC0CN1,ENADC,ACCE
       mvl     7    
  ADCENONSTEPLOOP:
       bsf      ADC0CN1,ENADC,ACCE
       bcf      ADC0CN1,ENADC,ACCE
       dcsz    wreg,f,acce
       jmp     ADCENONSTEPLOOP
       ret
       
       include   S24CXX.asm
    END     